
export default class SettingUtils {
  /**
   * @description 生成页面查询语句
   * @return {Object}  setting       页面设置
   */
  static getDebugSql (setting) {
    let sql = ''
    let _dataresource = setting.dataresource
    let _customScript = setting.customScript

    if (setting.interType === 'inner' && !setting.innerFunc && setting.default === 'false') {
      _dataresource = ''
    }
    
    if (_dataresource) {
      _dataresource = _dataresource.replace(/@\$|\$@/ig, '')
    }
    if (_customScript) {
      _customScript = _customScript.replace(/@\$|\$@/ig, '')
    }

    if (_customScript) {
      _customScript = _customScript.replace(/@orderBy@/ig, setting.order)
    }

    // 数据源处理
    if (_dataresource) {
      if (/\s/.test(_dataresource)) {
        _dataresource = '(' + _dataresource + ') tb'
      }

      let arr_field = `${setting.valueField}, ${setting.labelField}, ${setting.parentField}`

      _dataresource = `select ${arr_field} from (select ${arr_field} ,ROW_NUMBER() over(order by ${setting.order}) as rows from ${_dataresource}) tmptable order by tmptable.rows`
    }

    if (_customScript) {
      sql = `${_customScript}
        ${_dataresource}
        aaa:
        if @ErrorCode!=''
          insert into tmp_err_retmsg (ID, ErrorCode, retmsg, CreateUserID) select @time_id@,@ErrorCode, @retmsg,@UserID@
      `
    } else {
      sql = _dataresource
    }
    
    return sql
  }
}